"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_usestateref_1 = __importDefault(require("react-usestateref"));
const styles_1 = require("./styles");
const styled_components_1 = require("styled-components");
const util_1 = require("../../utils/util");
const Drawer = (props) => {
    const state = (0, react_usestateref_1.default)(false);
    const toggle = () => {
        state?.[1]?.(!state?.[0]);
    };
    const open = () => {
        state?.[1]?.(true);
    };
    const close = () => {
        state[1](false);
    };
    const filterIndexes = (indexes, children = 0) => {
        const filtered = indexes.map(index => index - children).filter(index => index >= 0);
        return JSON.parse(JSON.stringify(filtered));
    };
    const passProps = (elements, toggleIndexes, openIndexes, closeIndexes, noClickIndexes) => {
        // console.log('children passProps', elements, toggleIndexes, openIndexes, closeIndexes, noClickIndexes);
        return (react_1.default.Children.map?.(elements, (child, index) => {
            let has = (0, util_1.exists)(openIndexes, index);
            let drawerAction;
            if (has) {
                drawerAction = open;
                has = (0, util_1.exists)(closeIndexes, index);
                if (has) {
                    drawerAction = toggle;
                }
            }
            else {
                has = (0, util_1.exists)(closeIndexes, index);
                if (has) {
                    drawerAction = close;
                }
            }
            has = (0, util_1.exists)(toggleIndexes, index);
            if (has) {
                drawerAction = toggle;
            }
            const newProps = {
                onClick: drawerAction,
                drawerAction: drawerAction,
                drawerState: state,
                drawerOpen: open,
                drawerClose: close,
                drawerToggle: toggle,
            };
            has = (0, util_1.exists)(noClickIndexes, index);
            if (drawerAction == undefined && has)
                delete newProps.onClick;
            // console.log('children newProps', newProps);
            const cloneChild = react_1.default.cloneElement(child, newProps);
            return cloneChild;
        }));
    };
    const passPropsToNav = (elements, toggleIndexes, openIndexes, closeIndexes, noClickIndexes) => {
        let currentToggleIndexes = JSON.parse(JSON.stringify(toggleIndexes || []));
        let currentOpenIndexes = JSON.parse(JSON.stringify(openIndexes || []));
        let currentCloseIndexes = JSON.parse(JSON.stringify(closeIndexes || []));
        let currentNoClickIndexes = JSON.parse(JSON.stringify(noClickIndexes || []));
        return (elements &&
            react_1.default.Children.map(elements, (child, _index) => {
                const newProps = {
                    toggleIndexes: currentToggleIndexes,
                    openIndexes: currentOpenIndexes,
                    closeIndexes: currentCloseIndexes,
                    noClickIndexes: currentNoClickIndexes,
                    drawerState: state,
                };
                // console.log('newProps base', child);
                const cloneChild = react_1.default.cloneElement(child, newProps);
                const length = react_1.default.Children.count(child.props?.children);
                currentToggleIndexes = filterIndexes(currentToggleIndexes, length);
                currentOpenIndexes = filterIndexes(currentOpenIndexes, length);
                currentCloseIndexes = filterIndexes(currentCloseIndexes, length);
                currentNoClickIndexes = filterIndexes(currentNoClickIndexes, length);
                return cloneChild;
            }));
    };
    const [children, setChildren] = (0, react_usestateref_1.default)(props.children ? (passProps(props.children, props.childrenToggleIndexes, props.childrenOpenIndexes, props.childrenCloseIndexes, props.childrenNoClickIndexes)) : (react_1.default.createElement(react_1.default.Fragment, null)));
    const [navElements, setNavElements] = (0, react_usestateref_1.default)(props?.nav?.props?.children ? (passPropsToNav(props?.nav?.props?.children, props.navToggleIndexes, props.navOpenIndexes, props.navCloseIndexes, props.navNoClickIndexes)) : (react_1.default.createElement(react_1.default.Fragment, null)));
    (0, react_1.useEffect)(() => {
        setChildren(props.children ? (passProps(props.children, props.childrenToggleIndexes, props.childrenOpenIndexes, props.childrenCloseIndexes, props.childrenNoClickIndexes)) : (react_1.default.createElement(react_1.default.Fragment, null)));
        setNavElements(props?.nav?.props?.children ? (passPropsToNav(props?.nav?.props?.children, props.navToggleIndexes, props.navOpenIndexes, props.navCloseIndexes, props.navNoClickIndexes)) : (react_1.default.createElement(react_1.default.Fragment, null)));
    }, [props?.children, props?.nav?.props?.children, state?.[0]]);
    return (react_1.default.createElement(styles_1.DrawerWrapper, { className: state?.[0] ? 'openned' : 'closed', top: props.top },
        react_1.default.createElement(styles_1.DrawerHolder, { className: state?.[0] ? 'openned' : 'closed' }, navElements),
        react_1.default.createElement(styles_1.DrawerMenu, { className: state?.[0] ? 'openned' : 'closed', top: props.top }, children)));
};
exports.default = (0, styled_components_1.withTheme)(Drawer);
//# sourceMappingURL=index.js.map