"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NavList = exports.DrawerHolder = exports.DrawerWrapper = exports.DrawerMenu = exports.DrawerSubItem = exports.DrawerItem = exports.Holder = exports.IconItem = exports.ItemList = exports.ItemHolder = exports.BasicItemHolder = exports.StyledFooter = exports.StyledHeader = void 0;
const styled_components_1 = __importStar(require("styled-components"));
const config_1 = require("../../utils/config");
exports.StyledHeader = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  display: block;
  justify-content: center;
  width: 100%;
  height: fit-content;
  background: ${(props) => props.menu == 0 ? props.theme.background + "E0" : "transparent"};
  mix-blend-mode: ${(props) => props.menu == 2 ? "difference" : "unset"};
  position: fixed;
  z-index: 999;
  ${(props) => props.theme.hasShadow && (0, styled_components_1.css) `
    box-shadow: 0px 2px 5px ${(props) => props.theme.shadow};
  `}
  ${(props) => !props.theme.hasShadow && (0, styled_components_1.css) `
    border-bottom: 1px  solid ${(props) => props.theme.shadow};
  `}
`;
exports.StyledFooter = styled_components_1.default.footer `
  ${(props) => (0, config_1.baseConfig)(props)}
  display: block;
  position: fixed;
  bottom: ${(props) => props?.theme?.menu?.height || '70px'};
  left: 0;
  width: 100%;
  justify-content: center;
  margin: 0 auto;
  // padding: 5px 24px;
  background: ${(props) => props.theme.background};
  mix-blend-mode: ${(props) => props.menu == 2 ? "difference" : "unset"};
  position: fixed;
  z-index: 999;
  ${(props) => props.theme.hasShadow && (0, styled_components_1.css) `
    box-shadow: 0px 2px 5px ${(props) => props.theme.shadow};
  `}
  ${(props) => !props.theme.hasShadow && (0, styled_components_1.css) `
    border-top: 1px  solid ${(props) => props.theme.shadow};
  `}
`;
exports.BasicItemHolder = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  transition: all ${(props) => props?.theme?.transition?.logo?.duration || 0.2}s;
`;
exports.ItemHolder = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  display: table;
  margin: 0;
  min-height: ${(props) => props?.theme?.menu?.height || '70px'};
  width: 100%;
  min-width: 100%;
  cursor: pointer;
  border-top: 1px solid ${(props) => props.theme.holder};
  border-bottom: 1px solid ${(props) => props.theme.holder};
  background: ${(props) => props.theme.background};
  color: ${(props) => props.theme.primary};
  transition: none;
  font-weight: ${(props) => props?.theme?.menu?.font?.weight || 'normal'};
  font-size: ${(props) => props?.theme?.menu?.font?.size || '18px'}
  vertical-align: middle;
  align-content: center;
  align-items: center;
  align-self: center;
  alignment-baseline: central;
  text-align: center;
  box-align: center;

  a:visited, & :visited, :visited, &:visited {
    color: ${(props) => props.theme.primary};
  }

  a + a, div + div, div + a, a + div, & + a, & + div, & + & {
    border-top: 0;
  }

  a:hover, div:hover, &:hover, & :hover, :hover {
    background: ${(props) => props.theme.background};
    font-weight: ${(props) => props?.theme?.menu?.hover?.font?.weight || 'bold'};
    color: ${(props) => props.theme.bright};
  }

  div, a, span, & a, & span, & div {
    min-width: 100%;
    width: 100%;
    min-height: ${(props) => props?.theme?.menu?.height || '70px'};
    height: ${(props) => props?.theme?.menu?.height || '70px'};
    vertical-align: middle;
    align-content: center;
    align-items: center;
    align-self: center;
    alignment-baseline: central;
    text-align: center;
    box-align: center;
    margin-top: 25px;
    display: table-cell;
    box-sizing: border-box;
    font-weight: ${(props) => props?.theme?.menu?.font?.weight || 'bolder'};
    font-size: ${(props) => props?.theme?.menu?.font?.size || '18px'};
  }
`;
const itemSizes = {
    small: "35px",
    medium: "30px",
    large: "25px",
};
exports.ItemList = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  display: flex;

  @media screen and (max-width: 380px) {
    flex-wrap: wrap;
  }
`;
exports.IconItem = styled_components_1.default.img `
  ${(props) => (0, config_1.baseConfig)(props)}
  cursor: pointer;
  height: ${(props) => props.size ? itemSizes[props.size] : props.height || "30px"};
  margin: 0 ${(props) => props.sides ? props.sides : "20px"};
`;
exports.Holder = styled_components_1.default.a `
  ${(props) => (0, config_1.baseConfig)(props)}
  cursor: pointer;
  background: ${(props) => props?.theme?.background || 'white'};
  color: ${(props) => props?.theme?.primary};
  transition: all ${(props) => props?.theme?.transition?.holder?.duration || 0.2}s;

  &: hover {
    background: ${(props) => props?.theme?.background || 'white'};
    color: ${(props) => props?.theme?.bright};
    ${(props) => props?.theme?.boldOnHover && 'font-weight: bold;'}
  }

  span {
    margin-top: ${(props) => props?.marginTop || "25px"};
    display: inline-block;
  }
`;
exports.DrawerItem = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  display: flex;
  flex-direction: column;
  text-align: center;
`;
exports.DrawerSubItem = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  display: block;
  width: 100%;
  text-align: center;
`;
exports.DrawerMenu = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  position: relative;
  visibility: hidden;
  display: unset;
  top:${(props) => props.top ? `-${((props?.children?.length || 1) + 1) * 100}%` : '0%'};
  transition: all ${(props) => props?.theme?.transition?.drawer?.duration || 0.2}s ease;
  z-index: -10;
  opacity: 0;
  height: 0px;
  overflow: hidden;

  &.openned, &.open {
    overflow: initial;
    visibility: visible;
    display: block;
    top:${(props) => props.top ? '0%' : `-${((props?.children?.length || 1) + 1) * 100}%`};
    transition: all transform ${(props) => props?.theme?.transition?.drawer?.duration || 0.2}s ease;
    opacity: 1;
    background-color: ${(props) => props.theme.background};
    height: fit-content;
  }

  &.closed {
    overflow: hidden;
    display: unset;
    visibility: hidden;
    top:${(props) => props.top ? `-${((props?.children?.length || 1) + 1) * 100}%` : '0%'};
    transition: all transform ${(props) => props?.theme?.transition?.drawer?.duration || 0.2}s ease;
    opacity: 0;
    height: 0px;
  }
`;
exports.DrawerWrapper = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  height: ${(props) => props?.theme?.menu?.height || '70px'};
  width: 100%;
  left: 0;
  display: block;
  position: relative;
  z-index: 1000;
  ${(props) => props.top ? 'top: 0' : 'bottom: 0'};
  overflow: hidden;

  &.openned, &.open {
    overflow: initial;
  }

  &.closed {
    overflow: hidden;
  }
`;
exports.DrawerHolder = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  display: flex;
  align-items: center;
  justify-content: space-between;
  height: 100%;
  width: 100%;
  padding: 15px 30px;
  z-index: 1000;
  // border-bottom: ${(props) => props.theme.primary} 1px solid;
  box-sizing: border-box;
`;
exports.NavList = styled_components_1.default.div `
  display: flex;
`;
//# sourceMappingURL=styles.js.map