"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Coffee = exports.Theme = exports.APTI = exports.PathL = exports.Path = void 0;
const styled_components_1 = __importDefault(require("styled-components"));
const config_1 = require("../../../utils/config");
exports.Path = styled_components_1.default.path `
  ${(props) => (0, config_1.baseConfig)(props)}
  stroke: ${(props) => props?.theme?.primary || 'black'} !important;
  ${(props) => props.withFill ? "fill: " + props?.theme?.primary + "!important;" : ""}
`;
exports.PathL = styled_components_1.default.path `
  ${(props) => (0, config_1.baseConfig)(props)}
  stroke: ${(props) => props?.theme?.holder} !important;
  ${(props) => props.withFill ? "fill: " + props?.theme?.holder + "!important;" : ""}
`;
exports.APTI = styled_components_1.default.svg `
  ${(props) => (0, config_1.baseConfig)(props)}
  width: auto;
  max-width: 50%;
  height: auto;
  max-height: 45%;
  align-self: center;

  @media screen and (max-width: 1000px) {
    max-width: 80%;
    max-height: 45%;
  }

  @media (orientation: landscape) {
    max-width: 45%;
    max-height: 80%;
  }
`;
exports.Theme = styled_components_1.default.svg `
  ${(props) => (0, config_1.baseConfig)(props)}
  cursor: pointer;
`;
exports.Coffee = styled_components_1.default.svg `
${(props) => (0, config_1.baseConfig)(props)}
--secondary: ${(props) => props?.theme?.primary || 'black'} !important;
height: 100%;
align-self: center;
padding-top: 10px;

#steamL {
  stroke-dasharray: 13;
  stroke-dashoffset: 13;
  animation: steamLarge ${(props) => props?.theme?.animation?.steamLarge?.duration || 2}s infinite;
}
#steamR {
  stroke-dasharray: 9;
  stroke-dashoffset: 9;
  animation: steamSmall ${(props) => props?.theme?.animation?.steamSmall?.duration || 2}s infinite;
}
@-moz-keyframes swing {
  50% {
    transform: rotate(-3deg);
  }
}
@-webkit-keyframes swing {
  50% {
    transform: rotate(-3deg);
  }
}
@-o-keyframes swing {
  50% {
    transform: rotate(-3deg);
  }
}
@keyframes swing {
  50% {
    transform: rotate(-3deg);
  }
}
@-moz-keyframes steamLarge {
  0% {
    stroke-dashoffset: 13;
    opacity: 1;
  }
  50% {
    stroke-dashoffset: 39;
    opacity: 0;
  }
  100% {
    stroke-dashoffset: 39;
    opacity: 1;
  }
}
@-webkit-keyframes steamLarge {
  0% {
    stroke-dashoffset: 13;
    opacity: 1;
  }
  50% {
    stroke-dashoffset: 39;
    opacity: 0;
  }
  100% {
    stroke-dashoffset: 39;
    opacity: 1;
  }
}
@-o-keyframes steamLarge {
  0% {
    stroke-dashoffset: 13;
    opacity: 1;
  }
  50% {
    stroke-dashoffset: 39;
    opacity: 0;
  }
  100% {
    stroke-dashoffset: 39;
    opacity: 1;
  }
}
@keyframes steamLarge {
  0% {
    stroke-dashoffset: 13;
    opacity: 1;
  }
  50% {
    stroke-dashoffset: 39;
    opacity: 0;
  }
  100% {
    stroke-dashoffset: 39;
    opacity: 1;
  }
}
@-moz-keyframes steamSmall {
  0% {
    stroke-dashoffset: 9;
    opacity: 1;
  }
  50% {
    stroke-dashoffset: 27;
    opacity: 0;
  }
  100% {
    stroke-dashoffset: 27;
    opacity: 1;
  }
}
@-webkit-keyframes steamSmall {
  0% {
    stroke-dashoffset: 9;
    opacity: 1;
  }
  50% {
    stroke-dashoffset: 27;
    opacity: 0;
  }
  100% {
    stroke-dashoffset: 27;
    opacity: 1;
  }
}
@-o-keyframes steamSmall {
  0% {
    stroke-dashoffset: 9;
    opacity: 1;
  }
  50% {
    stroke-dashoffset: 27;
    opacity: 0;
  }
  100% {
    stroke-dashoffset: 27;
    opacity: 1;
  }
}
@keyframes steamSmall {
  0% {
    stroke-dashoffset: 9;
    opacity: 1;
  }
  50% {
    stroke-dashoffset: 27;
    opacity: 0;
  }
  100% {
    stroke-dashoffset: 27;
    opacity: 1;
  }
}
`;
//# sourceMappingURL=styles.js.map