"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_usestateref_1 = __importDefault(require("react-usestateref"));
const clsx_1 = __importDefault(require("clsx"));
const styles_1 = require("./styles");
// import "react-responsive-carousel/lib/styles/carousel.min.css"; // requires a loader
const react_responsive_carousel_1 = require("react-responsive-carousel");
const styled_components_1 = require("styled-components");
const Input_1 = __importDefault(require("../Input"));
const getMaxHeight = (props, titleHeightOffset) => 'calc(100%' +
    (props.hasTitle ? ' ' + titleHeightOffset + ' - 20px - 0.5rem' : '') +
    (props.hasDescription ? ' ' + titleHeightOffset + ' - 20px - 0.5rem' : '') +
    ')';
function Image(props) {
    const imgRef = (0, react_1.useRef)();
    const [loaded, setLoaded] = (0, react_usestateref_1.default)(false);
    const [titleHeightOffset, setTitleHeightOffset] = (0, react_usestateref_1.default)('- 1.3rem - 0.6vw');
    const [maxHeight, setMaxHeight] = (0, react_usestateref_1.default)(getMaxHeight(props, titleHeightOffset));
    (0, react_1.useEffect)(() => {
        if (imgRef.current && imgRef.current.complete) {
            setLoaded(true);
        }
    }, []);
    (0, react_1.useEffect)(() => { }, [
        props.disabled,
        props.images,
        props.images?.length,
        props.leftElement,
        props.rightElement,
    ]);
    (0, react_1.useEffect)(() => {
        if (props.titleElement) {
            setTitleHeightOffset(`- ${props.titleElement.clientHeight}px`);
        }
    }, [props.titleElement]);
    (0, react_1.useEffect)(() => {
        const maxHeight = getMaxHeight(props, titleHeightOffset);
        setMaxHeight(maxHeight);
    }, [props.hasDescription, props.hasTitle, titleHeightOffset]);
    const onChange = (index, _item) => {
        props?.setIndex?.(index);
    };
    const arrowStyles = {
        position: 'absolute',
        zIndex: 1,
        top: 'calc(100% - 45px)',
    };
    const baseIndicator = {
        display: 'inline-block',
        margin: '5px 10px',
    };
    const selection = (isSelected) => {
        return isSelected ? { opacity: 1 } : {};
    };
    const preventDefault = (e) => {
        e.stopPropagation();
        e.preventDefault();
        return true;
    };
    return (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(styles_1.CarouselHolder, { onClick: props?.onClick, style: { cursor: props?.onClick ? 'pointer' : 'auto' } },
            react_1.default.createElement(react_responsive_carousel_1.Carousel, { selectedItem: props.index || 0, autoPlay: props?.autoPlay || false, interval: props?.interval || 3000, infiniteLoop: props?.infiniteLoop || false, showThumbs: props?.showThumbs || false, showStatus: props?.showStatus || false, showIndicators: props?.images?.length !== undefined &&
                    props?.images?.length !== null &&
                    props?.images?.length > 1, swipeable: true, emulateTouch: true, dynamicHeight: props?.dynamicHeight != undefined ? props?.dynamicHeight : true, useKeyboardArrows: true, onChange: onChange, onSwipeStart: preventDefault, onSwipeEnd: preventDefault, onSwipeMove: preventDefault, onClickItem: props?.onClickItem, onClickThumb: props?.onClickThumb, renderArrowPrev: (onClick, hasPrev) => hasPrev && (react_1.default.createElement(Input_1.default, { type: 'button', onClick: (e) => {
                        preventDefault(e);
                        onClick();
                    }, style: { ...arrowStyles, left: 15 }, value: props.left || '❮' || '◃' || '◀' || '◁' || '◂' || '⦉' })), renderArrowNext: (onClick, hasNext) => hasNext && (react_1.default.createElement(Input_1.default, { type: 'button', onClick: (e) => {
                        preventDefault(e);
                        onClick();
                    }, style: { ...arrowStyles, right: 15 }, value: props.right || '❯' || '▹' || '▶' || '▷' || '▸' || '⦊' })), renderIndicator: (onClick, isSelected, index) => {
                    return (react_1.default.createElement(styles_1.Indicator, { onClick: (e) => {
                            preventDefault(e);
                            onClick(e);
                        }, onKeyDown: isSelected
                            ? (e) => {
                                preventDefault(e);
                                onClick(e);
                            }
                            : undefined, value: index, key: index, role: "button", tabIndex: 0, title: `${index + 1}`, "aria-label": `${index + 1}`, style: {
                            ...baseIndicator,
                            ...selection(isSelected),
                        } }));
                } }, props?.images?.map((image, index) => {
                return (react_1.default.createElement("div", { key: index, style: {
                        filter: 'grayscale(' + (props.disabled ? '1' : '0') + ')',
                    } },
                    react_1.default.createElement(styles_1.BackgroundImage, { alt: props.alt, src: props.lqip }),
                    react_1.default.createElement(styles_1.Image, { loading: "lazy", src: image, alt: props.alt, ref: imgRef, onLoad: () => setLoaded(true), className: (0, clsx_1.default)('source', loaded && 'loaded') + 'img-fluid', style: {
                            maxHeight: maxHeight,
                            height: maxHeight,
                            color: 'red',
                        } })));
            })),
            react_1.default.createElement(styles_1.LeftElementHolder, null, props.leftElement),
            react_1.default.createElement(styles_1.RightElementHolder, null, props.rightElement))));
}
exports.default = (0, styled_components_1.withTheme)(Image);
//# sourceMappingURL=index.js.map