"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importStar(require("react"));
const react_usestateref_1 = __importDefault(require("react-usestateref"));
const styles_1 = require("./styles");
const styled_components_1 = require("styled-components");
const Text_1 = require("../Text");
const lodash_debounce_1 = __importDefault(require("lodash.debounce"));
const lodash_throttle_1 = __importDefault(require("lodash.throttle"));
const stopPropagation = (event) => {
    event?.stopImmediatePropagation?.();
    event?.stopPropagation?.();
    event?.nativeEvent?.stopPropagation?.();
    event?.nativeEvent?.stopImmediatePropagation?.();
};
const checkAndstopPropagation = (stop, event) => {
    if (stop)
        stopPropagation(event);
};
const isChecked = (value) => {
    const checked = typeof value === 'string'
        ? value.toLowerCase() !== 'false' && value.toLowerCase() !== '0'
        : !!value;
    // console.log('checked', value, checked);
    return checked;
};
const Input = (props) => {
    const [type, setType] = (0, react_usestateref_1.default)(props?.type?.toLowerCase?.() || 'text');
    const [running, setRunning] = (0, react_usestateref_1.default)(false);
    const inputRef = (0, react_1.useRef)(null);
    const [value, setValue] = (0, react_usestateref_1.default)(props.defaultValue || props.value); // internal value
    // const [checked, setChecked] = useState<boolean | undefined>(type === 'checkbox' || type === 'radio' ? isChecked(value) : undefined); // internal value
    const valueState = props?.setValue // external value
        ? [props?.value, props?.setValue, undefined]
        : (0, react_usestateref_1.default)(value);
    const errorState = props?.setError
        ? undefined
        : (0, react_usestateref_1.default)(props.defaultError || props.error);
    (0, react_1.useEffect)(() => {
        setType(props?.type?.toLowerCase?.() || 'text');
    }, [props?.type]);
    // useEffect(() => {
    //   if (type === 'checkbox' || type === 'radio') {
    //     const newChecked = isChecked(value);
    //     if(newChecked !== checked) setChecked(newChecked);
    //   }
    // }, [value]);
    (0, react_1.useEffect)(() => { }, [type]);
    (0, react_1.useEffect)(() => { }, [props?.error]);
    (0, react_1.useEffect)(() => { }, [props, Object.values(props)]);
    const remakeOnChange = (event, func) => {
        const currentFunc = (a, b, c, d, e) => {
            return basicValidate?.(a, b, c, d, e, func);
        };
        return validateLength(event, currentFunc);
    };
    const remakeEvent = (event, func) => {
        checkAndstopPropagation(props?.stopPropagation, event);
        return validateLength(event, func);
    };
    const onEnterEvent = (event) => {
        if (event?.key === 'Enter') {
            return onEnter(event);
        }
    };
    const onBlur = (event) => {
        return basicValidate(event, event?.currentTarget?.value, valueState, props?.error || errorState?.[0], props?.setError || errorState?.[1], props?.onChange);
    };
    const onEnter = (event) => {
        return basicValidate(event, event?.currentTarget?.value, valueState, props?.error || errorState?.[0], props?.setError || errorState?.[1], props?.onChange);
    };
    const validateExecution = (func, currentParameter) => {
        // console.log('validateExecution', props);
        const options = props?.options;
        const finalFunction = (...args) => {
            const result = func?.(...args);
            setRunning(false);
            return result;
        };
        if (!running)
            switch (options?.type) {
                case 'debounce':
                    // console.log('debounce', props);
                    setRunning(true);
                    return (0, lodash_debounce_1.default)(finalFunction, options?.wait || 250, options)(...currentParameter);
                case 'throttle':
                    // console.log('throttle', props);
                    setRunning(true);
                    return (0, lodash_throttle_1.default)(finalFunction, options?.wait || 250, options)(...currentParameter);
                default:
                    // console.log('default', props);
                    return func?.(...currentParameter);
            }
    };
    const updateValue = (newValue) => {
        if (type === 'checkbox' || type === 'radio') {
            newValue = !isChecked(value);
            // setChecked(newValue);
        }
        // console.log('updateValue', value, newValue);
        setValue(newValue);
        return newValue;
    };
    const validateLength = (event, func) => {
        const oldValue = valueState?.[0];
        let value = event?.target?.value || event?.currentTarget?.value;
        value = updateValue(value);
        const options = props?.options;
        const currentFunction = func ? func : valueState?.[1];
        const currentParameter = func
            ? [
                event,
                value,
                valueState,
                props?.error || errorState?.[0],
                props?.setError || errorState?.[1],
                func,
            ]
            : [value];
        // console.log(
        //   'validateLength',
        //   oldValue,
        //   value,
        //   currentParameter,
        //   options,
        //   event
        // );
        if (options != undefined) {
            if (oldValue === value)
                return;
            const oldLength = oldValue?.length || 0;
            const length = value?.length || 0;
            const minLength = options?.minLength || 0;
            if (length >= minLength)
                return validateExecution(currentFunction, currentParameter);
            else if (oldLength > length) {
                // event = {
                //   ...event,
                //   target: { ...event?.target, value: '' },
                // } as React.FormEvent<HTMLInputElement>;
                return validateExecution(currentFunction, currentParameter);
            }
        }
        else {
            return currentFunction(...currentParameter);
        }
    };
    const basicValidate = (event, value, valueState, error, setError, eventF) => {
        // console.log('basicValidate', event, value, valueState);
        checkAndstopPropagation(props?.stopPropagation, event);
        if (props?.validate)
            props.validate(value, valueState, error, setError, event, eventF);
        else {
            valueState?.[1]?.(value);
            setError?.(error);
        }
        return eventF?.(event, value, valueState, error, setError);
    };
    const getProps = () => {
        const newProps = JSON.parse(JSON.stringify(props));
        delete newProps.error;
        delete newProps.setError;
        delete newProps.setValue;
        delete newProps.children;
        delete newProps.label;
        delete newProps.labelStyle;
        delete newProps.labelParentStyle;
        delete newProps.errorStyle;
        newProps.validate = props.validate;
        newProps.defaultValue = props?.value ? undefined : props?.defaultValue;
        if (type === 'checkbox' || type === 'radio')
            newProps.checked = valueState?.[0];
        newProps.value = valueState?.[0];
        // console.log('getProps', props);
        newProps.onChange = (event) => {
            return remakeOnChange(event, props?.onChange);
        };
        if (type !== 'checkbox' && type !== 'radio') {
            newProps.onClick = (event) => {
                return remakeEvent(event, props?.onClick);
            };
            newProps.onInput = (event) => {
                return remakeEvent(event, props?.onInput);
            };
            newProps.onSubmit = (event) => {
                return remakeEvent(event, props?.onSubmit);
            };
            newProps.onKeyUp = (event) => {
                return remakeEvent(event, props?.onKeyUp);
            };
            newProps.onKeyDown = (event) => {
                if (props?.options?.type != undefined &&
                    props?.options?.forceNotifyByEnter)
                    return onEnterEvent(event);
                return remakeEvent(event, props?.onKeyDown);
            };
            newProps.onBlur = (event) => {
                if (props?.options?.type != undefined &&
                    props?.options?.forceNotifyOnBlur)
                    return onBlur(event);
                return remakeEvent(event, props?.onBlur);
            };
        }
        else
            newProps.checked = value;
        if (newProps.value != undefined && newProps.checked != undefined)
            delete newProps.defaultValue;
        return newProps;
    };
    const input = type === 'file' ? (react_1.default.createElement(react_1.default.Fragment, null,
        react_1.default.createElement(styles_1.Input, { ...{ ...getProps(), value: '' }, style: { display: 'none' }, ref: inputRef }),
        react_1.default.createElement(styles_1.Input, { ...{ ...getProps(), type: 'button' }, onClick: (event) => {
                // console.log('CLICK');
                // console.log('click', inputRef?.current);
                checkAndstopPropagation(props?.stopPropagation, event);
                inputRef?.current?.click();
            } }))) : (react_1.default.createElement(styles_1.Input, { ...getProps(), ref: inputRef }));
    const fullInput = props.label ? (react_1.default.createElement("label", { style: props.labelParentStyle },
        react_1.default.createElement("span", { style: props.labelStyle }, props.label),
        input)) : (input);
    return (react_1.default.createElement(react_1.default.Fragment, null,
        fullInput,
        props?.error && props?.error !== '' && props?.error !== ' ' ? (react_1.default.createElement(Text_1.Error, { style: props?.errorStyle }, props?.error)) : null));
};
exports.default = (0, styled_components_1.withTheme)(Input);
//# sourceMappingURL=index.js.map