"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getFlow = exports.FlowType = exports.Bar = exports.Milk = exports.SVG = exports.Progress = void 0;
const react_1 = __importStar(require("react"));
const react_usestateref_1 = __importDefault(require("react-usestateref"));
const Text_1 = require("../../Text");
const styled_components_1 = require("styled-components");
var FlowType;
(function (FlowType) {
    FlowType[FlowType["leftToRight"] = 0] = "leftToRight";
    FlowType[FlowType["rightToLeft"] = 1] = "rightToLeft";
    FlowType[FlowType["bottomToTop"] = 2] = "bottomToTop";
    FlowType[FlowType["topToBottom"] = 3] = "topToBottom";
})(FlowType || (FlowType = {}));
exports.FlowType = FlowType;
;
const getFlow = (flow, min, max) => {
    const half = (min + max) / 2;
    switch (flow) {
        case FlowType.leftToRight:
            return { x1: `${min}`, y1: `${half}`, x2: `${max}`, y2: `${half}` };
        case FlowType.rightToLeft:
            return { x1: `${max}`, y1: `${half}`, x2: `${min}`, y2: `${half}` };
        case FlowType.bottomToTop:
            return { x1: `${half}`, y1: `${max}`, x2: `${half}`, y2: `${min}` };
        case FlowType.topToBottom:
            return { x1: `${half}`, y1: `${min}`, x2: `${half}`, y2: `${max}` };
        default: undefined;
    }
};
exports.getFlow = getFlow;
const SVGB = (props) => {
    (0, react_1.useEffect)(() => {
    }, [props, ...Object.values(props)]);
    const getProps = () => {
        const newProps = {};
        for (const key in props) {
            if (key !== 'height' &&
                key !== 'width' &&
                key !== 'children' &&
                key !== 'style' &&
                Object.prototype.hasOwnProperty.call(props, key)) {
                newProps[key] = props[key];
            }
        }
        return newProps;
    };
    return (react_1.default.createElement("svg", { height: "100%", width: "100%", viewBox: `0 0 ${props.width} ${props.height}`, xmlns: "http://www.w3.org/2000/svg", style: props.style, ...getProps() }, props.children));
};
const SVG = (0, styled_components_1.withTheme)(SVGB);
exports.SVG = SVG;
const BarB = (props) => {
    const [id] = (0, react_usestateref_1.default)('lg' + (props.id || 0));
    const [time] = (0, react_usestateref_1.default)(props.time || 1);
    const [_max, setMax] = (0, react_usestateref_1.default)((props.max || 1) / (props.max || 1));
    const [min, setMin] = (0, react_usestateref_1.default)((props.min || 0) / (props.max || 1));
    const [current, setCurrent] = (0, react_usestateref_1.default)((props.current || props.max || 1) / (props.max || 1));
    const [flow, setFlow] = (0, react_usestateref_1.default)(getFlow(props.flow, (props.min || 0) / (props.max || 1), (props.max || 1) / (props.max || 1)));
    const [fillColor] = (0, react_usestateref_1.default)(props.fillColor || '#000000');
    const [width] = (0, react_usestateref_1.default)(props.width || 200);
    const [height] = (0, react_usestateref_1.default)(props.height || 100);
    (0, react_1.useEffect)(() => {
        setMax((props.max || 1) / (props.max || 1));
    }, [props.max]);
    (0, react_1.useEffect)(() => {
        setMin((props.min || 0) / (props.max || 1));
    }, [props.min, props.max]);
    (0, react_1.useEffect)(() => {
        setCurrent((props.current || props.max || 1) / (props.max || 1));
    }, [props.current, props.max]);
    (0, react_1.useEffect)(() => {
        setFlow(getFlow(props.flow, (props.min || 0) / (props.max || 1), (props.max || 1) / (props.max || 1)));
    }, [props.flow, props.min, props.max]);
    (0, react_1.useEffect)(() => {
    }, [props, ...Object.values(props)]);
    return (flow ? (react_1.default.createElement(SVG, { height: height, width: width, style: props.style },
        react_1.default.createElement("linearGradient", { id: id, ...flow },
            react_1.default.createElement("stop", { offset: min, stopOpacity: "1", stopColor: fillColor }),
            react_1.default.createElement("stop", { offset: current, stopOpacity: "1", stopColor: fillColor },
                react_1.default.createElement("animate", { attributeName: "offset", from: min, to: current, dur: time + 's', begin: "0s" })),
            react_1.default.createElement("stop", { offset: current, stopOpacity: "0", stopColor: fillColor },
                react_1.default.createElement("animate", { attributeName: "offset", from: min, to: current, dur: time + 's', begin: "0s" })),
            react_1.default.createElement("stop", { offset: current, stopOpacity: "0", stopColor: fillColor })),
        react_1.default.createElement("path", { d: `M 0 0 L 0 ${height} L  ${props.width}  ${height} L ${props.width} 0 Z`, fill: 'url(#' + (id) + ')', fillRule: "evenodd", opacity: "1", stroke: props.fillColor, strokeLinecap: "round", strokeLinejoin: "round", strokeWidth: "5" }))) : (react_1.default.createElement(react_1.default.Fragment, null)));
};
const Bar = (0, styled_components_1.withTheme)(BarB);
exports.Bar = Bar;
const MilkB = (props) => {
    const [id] = (0, react_usestateref_1.default)('lg' + (props.id || 0));
    const [time] = (0, react_usestateref_1.default)(props.time || 1);
    const [_max, setMax] = (0, react_usestateref_1.default)((props.max || 1) / (props.max || 1));
    const [min, setMin] = (0, react_usestateref_1.default)((props.min || 0) / (props.max || 1));
    const [current, setCurrent] = (0, react_usestateref_1.default)((props.current || props.max || 1) / (props.max || 1));
    const [flow, setFlow] = (0, react_usestateref_1.default)(getFlow(props.flow, (props.min || 0) / (props.max || 1), (props.max || 1) / (props.max || 1)));
    const [fillColor] = (0, react_usestateref_1.default)(props.fillColor || '#000000');
    const height = 230;
    const width = 130;
    (0, react_1.useEffect)(() => {
        setMax((props.max || 1) / (props.max || 1));
    }, [props.max]);
    (0, react_1.useEffect)(() => {
        setMin((props.min || 0) / (props.max || 1));
    }, [props.min, props.max]);
    (0, react_1.useEffect)(() => {
        setCurrent((props.current || props.max || 1) / (props.max || 1));
    }, [props.current, props.max]);
    (0, react_1.useEffect)(() => {
        setFlow(getFlow(props.flow, (props.min || 0) / (props.max || 1), (props.max || 1) / (props.max || 1)));
    }, [props.flow, props.min, props.max]);
    (0, react_1.useEffect)(() => {
    }, [props, ...Object.values(props)]);
    return (flow ? (react_1.default.createElement(SVG, { height: height, width: width, style: props.style },
        react_1.default.createElement("linearGradient", { id: id, ...flow },
            react_1.default.createElement("stop", { offset: min, stopOpacity: "1", stopColor: fillColor }),
            react_1.default.createElement("stop", { offset: current, stopOpacity: "1", stopColor: fillColor },
                react_1.default.createElement("animate", { attributeName: "offset", from: min, to: current, dur: time + 's', begin: "0s" })),
            react_1.default.createElement("stop", { offset: current, stopOpacity: "0", stopColor: fillColor },
                react_1.default.createElement("animate", { attributeName: "offset", from: min, to: current, dur: time + 's', begin: "0s" })),
            react_1.default.createElement("stop", { offset: current, stopOpacity: "0", stopColor: fillColor })),
        react_1.default.createElement("path", { d: "M39.3416 2.5C39.3416 2.5 37.2794 3.42588 37.2794 4.37501C37.2794 5.32414 39.3416 6.25002 39.3416 6.25002L39.7924 31.0932L24.5471 46.93L5.40047 27.0422C5.40047 27.0422 3.94774 27.4803 3.43469 28.0128C2.92168 28.5453 2.5 30.055 2.5 30.055L21.6135 49.9439L6.40042 65.7804L6.85121 223.75C6.85121 223.75 4.78905 224.676 4.78905 225.625C4.78905 226.574 6.85121 227.5 6.85121 227.5L123.147 227.5C123.147 227.5 125.21 226.574 125.21 225.625C125.21 224.676 123.147 223.75 123.147 223.75L123.599 65.7804L108.384 49.9439L127.5 30.055C127.5 30.055 127.078 28.5453 126.566 28.0128C126.052 27.4793 124.597 27.0422 124.597 27.0422L105.453 46.93L90.2076 31.0932L90.6564 6.25002C90.6564 6.25002 92.7195 5.32414 92.7195 4.37501C92.7195 3.42588 90.6564 2.5 90.6564 2.5L39.3416 2.5Z", fill: 'url(#' + id + ')', fillRule: "evenodd", opacity: "1", stroke: props.fillColor, strokeLinecap: "round", strokeLinejoin: "round", strokeWidth: "5" }))) : (react_1.default.createElement(react_1.default.Fragment, null)));
};
const Milk = (0, styled_components_1.withTheme)(MilkB);
exports.Milk = Milk;
const ProgressB = (props) => {
    const passProps = (props) => {
        return (props.children &&
            react_1.default.Children.map(props.children, (child) => {
                return react_1.default.cloneElement(child, {
                    id: props.id,
                    flow: props.flow,
                    style: props.style,
                    height: props.height,
                    width: props.width,
                    min: props.min,
                    max: props.max,
                    current: props.current,
                    fillColor: props.fillColor || props.theme.primary,
                    time: props.time,
                });
            }));
    };
    (0, react_1.useEffect)(() => {
    }, [props, ...Object.values(props)]);
    return (react_1.default.createElement("div", { style: { position: "relative" } },
        passProps(props),
        props.percentage && react_1.default.createElement(Text_1.ProgressText, null,
            ((props.current || 0) / (props.max || 1)) * 100,
            "%"),
        (props.quantity || 0) > 1 && react_1.default.createElement(Text_1.Quantity, null, props.quantity)));
};
const Progress = (0, styled_components_1.withTheme)(ProgressB);
exports.Progress = Progress;
//# sourceMappingURL=index.js.map