"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = __importDefault(require("react"));
const react_modal_1 = __importDefault(require("react-modal"));
const styled_components_1 = require("styled-components");
const close_1 = __importDefault(require("../Input/close"));
const Text_1 = require("../Text");
const Modal = (props) => {
    return (react_1.default.createElement(react_modal_1.default, { appElement: document.getElementById('app'), isOpen: props.isOpen, 
        // onAfterOpen={afterOpenModal}
        onRequestClose: props.setClose, onRequestOpen: props.setOpen, style: {
            overlay: {
                backgroundColor: 'transparent',
            },
            content: {
                top: '80px',
                backgroundColor: props?.theme?.background,
                border: '1px solid ' + props?.theme?.primary,
                padding: '0px',
            },
        } },
        react_1.default.createElement("div", { style: {
                display: 'inline-flex',
                float: 'left',
                padding: '10px',
                boxSizing: 'border-box',
                width: '100%',
            } },
            react_1.default.createElement(Text_1.Text, { type: props.titleType, limitationType: props.titleLimitationType, style: {
                    marginBottom: '0',
                    display: 'inline-flex',
                    float: 'left',
                    margin: '0px',
                    boxSizing: 'border-box',
                } }, props.title || ''),
            react_1.default.createElement("div", { style: {
                    display: 'inline-flex',
                    float: 'right',
                    margin: '0px',
                    boxSizing: 'border-box',
                } },
                react_1.default.createElement(close_1.default, { setClose: props.setClose, iconType: props.iconType }))),
        react_1.default.createElement("div", { style: { margin: '20px', boxSizing: 'border-box' } }, props.children)));
};
exports.default = (0, styled_components_1.withTheme)(Modal);
//# sourceMappingURL=index.js.map