"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.NotificationWrapper = void 0;
const styled_components_1 = __importDefault(require("styled-components"));
const config_1 = require("../../utils/config");
const getElement = (props) => {
    const element = props.children || props.text;
    return element;
};
const hasText = (props) => {
    const element = getElement(props);
    return element && element.length > 0;
};
exports.NotificationWrapper = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  position: relative;
  display: flex;
  justify-content: center;
  width: 100%;
  white-space: pre-line;
  color: ${(props) => props.theme.background};
  background-color: ${(props) => props.error ? props.theme.error : props.theme.primary};
  height: ${(props) => hasText(props) ? 'auto' : '0px'};
  padding: ${(props) => hasText(props) > 0 ? '10px' : '0px'};
`;
//# sourceMappingURL=styles.js.map