"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
const ScrollToSection = (props) => {
    let currentSection = "#intro";
    const indexOfSmallest = (a) => {
        var lowest = 0;
        if (a)
            for (var i = 1; i < a.length; i++)
                if (a[i] < a[lowest])
                    lowest = i;
        return lowest;
    };
    const onScroll = () => {
        let els = [];
        let hrefs = [];
        for (const key in props?.map?.sections) {
            if (props?.map?.sections?.hasOwnProperty?.(key) && document?.getElementById?.(key)?.getBoundingClientRect?.()?.y) {
                els?.push?.(Math.abs(document?.getElementById?.(key)?.getBoundingClientRect?.()?.y || 0));
                hrefs?.push?.(props?.map?.sections?.[key]);
            }
        }
        let cEl = hrefs?.[indexOfSmallest(els)];
        if (currentSection !== cEl) {
            currentSection = (cEl);
            window?.history?.pushState?.("", "", currentSection ? ("#" + currentSection) : "");
        }
    };
    (0, react_1.useEffect)(() => {
        window?.addEventListener?.("scroll", onScroll);
        return () => {
            window?.removeEventListener?.("scroll", onScroll);
        };
    }, [ /*section*/]);
    return null;
};
exports.default = ScrollToSection;
//# sourceMappingURL=index.js.map