"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Col = exports.Row = exports.TH = exports.TR = exports.TD = exports.Table = void 0;
const styled_components_1 = __importDefault(require("styled-components"));
exports.Table = styled_components_1.default.table `
  border-collapse: collapse;
  width: 100%;
`;
exports.TD = styled_components_1.default.td `
  border: 1px solid ${(props) => props.theme.primary};
  text-align: left;
  padding: 10px;
`;
exports.TR = styled_components_1.default.tr `
  border: 1px solid ${(props) => props.theme.primary};
  text-align: left;
  padding: 10px;
`;
exports.TH = styled_components_1.default.th `
  border: 1px solid ${(props) => props.theme.primary};
  text-align: left;
  padding: 10px;
`;
exports.Row = styled_components_1.default.div `
  display: flex;
  flex-wrap: wrap;
  width: 100%;
`;
exports.Col = styled_components_1.default.div `
  display: flex;
  flex-direction: column;
  margin-bottom: 16px;

  &:not(:last-child) {
    margin-right: 24px;
  }

  @media screen and (max-width: 1033px) {
    width: 100%;
    &:not(:last-child) {
      margin-right: 0;
    }
  }
`;
//# sourceMappingURL=styles.js.map