"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.FixedLink = exports.AFixedLink = exports.Link = exports.ProgressText = exports.Quantity = exports.P = exports.Notification = exports.Error = exports.Text = void 0;
const styled_components_1 = __importDefault(require("styled-components"));
const config_1 = require("../../utils/config");
exports.Text = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  width: 100%;
  max-width: ${(props) => (0, config_1.textLimitation)(props?.theme)[(0, config_1.getTextLimitationType)(props?.limitationType)]};
  color: ${(props) => props?.color || props.theme.primary};
  margin: ${(props) => props.margin || (0, config_1.isHeading)(props.type) ? '10px' : '0px'};
  text-align: ${(props) => props.textAlign || 'justify'};
`;
exports.Error = (0, styled_components_1.default)(exports.Text) `
  color: ${(props) => props.theme.error};
  max-width: ${(props) => (0, config_1.textLimitation)(props?.theme)[(0, config_1.getTextLimitationType)(props?.limitationType || 'limited')]};
`;
exports.Notification = (0, styled_components_1.default)(exports.Text) `
  max-width: ${(props) => (0, config_1.textLimitation)(props?.theme)[(0, config_1.getTextLimitationType)(props?.limitationType || 'limited')]};
`;
exports.P = styled_components_1.default.p `
  ${(props) => (0, config_1.baseConfig)(props)}
  text-indent: 3ch;
  margin-bottom: 1em;
  line-height: 150%;
`;
exports.Quantity = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  display: block;
  width: 25px;
  height: 25px;
  font-size: ${(props) => props?.theme?.quantity?.font?.size || '10px'};
  font-weight: ${(props) => props?.theme?.quantity?.font?.weight || 'bold'};
  color: ${(props) => props.theme.background};
  background-color: ${(props) => props.theme.primary};
  text-align: center;
  position: absolute;
  border-radius: 100%;
  text-align: center;
  left: 20px;
  margin-top: -10px;
  padding-top: 7px;
`;
exports.ProgressText = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  display: block;
  mix-blend-mode: difference;
  color: white;
  text-align: center;
  position: absolute;
  border-radius: 100%;
  text-align: center;
  font-size: ${(props) => props?.theme?.progressText?.font?.size || '10px'};
  font-weight: ${(props) => props?.theme?.progressText?.font?.weight || 'bold'};

  left:0;
  right:0;

  margin-left: auto;
  margin-right: auto;
  top: 50%;
  bottom: 50%;
`;
exports.Link = styled_components_1.default.a `
  ${(props) => (0, config_1.baseConfig)(props)}
  text-decoration: none;
  color: ${(props) => props.theme.primary};
  padding: ${(props) => (props.icon ? '15px' : '0')};
  margin: ${(props) => (props.icon ? '10px' : '0')};
  cursor: pointer;
  border-radius: 6px;
  transition: all ${(props) => props?.theme?.transition?.link?.duration || 0.15}s;

  &:hover {
    color: ${(props) => (props.icon ? props.theme.primary : props.theme.primary)};
  }

  &:first-child {
    padding-left: 0;
    margin-left: 0;
  }

  &:last-child {
    padding-right: 0;
    margin-right: 0;
  }

  @media screen and (max-width: 380px) {
    &:first-child {
      padding: ${(props) => (props.icon ? '15px' : '0')};
      margin: ${(props) => (props.icon ? '10px' : '15px 0')};
    }

    &:last-child {
      padding: ${(props) => (props.icon ? '15px' : '0')};
      margin: ${(props) => (props.icon ? '10px' : '15px 0')};
    }
  }

  &:visited {
    color: ${(props) => props.theme.primary};
  }
`;
exports.AFixedLink = styled_components_1.default.a `
  ${(props) => (0, config_1.baseConfig)(props)}
  color: ${(props) => props.theme.primary};
  margin: 0 20px;
  position: relative;
  cursor: pointer;
  transition: all ${(props) => props?.theme?.transition?.fixedLink?.duration || 0.15}s ease-in-out;

  &:before {
    content: '';
    position: absolute;
    height: 2px;
    bottom: -3px;
    left: 0;
    // visibility: hidden;
    width: 0;
  }

  &:hover {
    &:before {
      background-color: ${(props) => props.theme.primary};
      visibility: visible;
      width: 100%;
    }
  }

  &:visited {
    color: ${(props) => props.theme.primary};
  }
`;
exports.FixedLink = styled_components_1.default.div `
  ${(props) => (0, config_1.baseConfig)(props)}
  color: ${(props) => props.theme.primary};
  margin: 0 20px;
  position: relative;
  cursor: pointer;
  transition: all ${(props) => props?.theme?.transition?.fixedLink?.duration || 0.15}s ease-in-out;

  &:before {
    content: '';
    position: absolute;
    height: 2px;
    bottom: -3px;
    left: 0;
    // visibility: hidden;
    width: 0;
  }

  &:hover {
    &:before {
      background-color: ${(props) => props.theme.primary};
      visibility: visible;
      width: 100%;
    }
  }

  &:visited {
    color: ${(props) => props.theme.primary};
  }
`;
//# sourceMappingURL=index.js.map