"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.formatCurrency = exports.createLanguageSetterContext = exports.createLanguageContext = void 0;
const react_1 = require("react");
const createLanguageContext = (language) => (0, react_1.createContext)(language);
exports.createLanguageContext = createLanguageContext;
const createLanguageSetterContext = (value) => (0, react_1.createContext)(value);
exports.createLanguageSetterContext = createLanguageSetterContext;
const formatCurrency = (format, price) => {
    if (price == undefined)
        return undefined;
    if (format?.locale == undefined)
        return price;
    const formatter = new Intl.NumberFormat(format.locale, {
        style: 'currency',
        currency: format.currency,
        // These options are needed to round to whole numbers if that's what you want.
        minimumFractionDigits: format.minimumFractionDigits,
        maximumFractionDigits: format.maximumFractionDigits, // (causes 2500.99 to be printed as $2,501)
    });
    return formatter.format(price);
};
exports.formatCurrency = formatCurrency;
//# sourceMappingURL=language.js.map