/// <reference types="node" />
/// <reference types="cypress" />
/// <reference types="node" />
/// <reference types="node" />
/// <reference types="node" />
/// <reference types="react" />
declare const catalog: {
    id: string;
    name: string;
    identification: string;
    type: string;
};
export declare enum UserFlow {
    base = 0,
    last = 1,
    current = 2
}
export declare enum UserType {
    none = 0,
    base = 1,
    client = 2,
    regular = 3,
    seller = 4
}
declare const getStorageToken: (storage: number) => string | undefined;
declare const refreshToken: (token: (flow: UserFlow) => string | undefined, setToken: (flow: UserFlow, string?: string | undefined) => void, setUser: (flow: UserFlow, newUser: any) => void, timeout?: ((flow: UserFlow) => NodeJS.Timeout | undefined) | undefined, setTimeout?: ((flow: UserFlow, newTimeout: NodeJS.Timeout | undefined) => void) | undefined, timeoutFunction?: ((flow: UserFlow, token?: any) => void) | undefined, setTimeoutFunction?: ((flow: UserFlow, timeoutFunction?: ((token?: any) => void) | undefined) => void) | undefined, address?: string, path?: string, data?: string, offset?: number, refreshMethod?: string) => Promise<string | undefined>;
declare const signOut: (token: (flow: UserFlow) => string | undefined, setToken: (flow: UserFlow, string?: string | undefined) => void, setUser: (flow: UserFlow, newUser: any) => void, timeout?: ((flow: UserFlow) => NodeJS.Timeout | undefined) | undefined, setTimeout?: ((flow: UserFlow, newTimeout: NodeJS.Timeout | undefined) => void) | undefined, timeoutFunction?: ((flow: UserFlow, token?: any) => void) | undefined, setTimeoutFunction?: ((flow: UserFlow, timeoutFunction?: ((token?: any) => void) | undefined) => void) | undefined, offset?: number, refreshMethod?: string, clear?: boolean) => Promise<string | undefined>;
declare const getUserType: (user: any) => UserType;
declare const getUserFlow: (userType: UserType) => UserFlow;
declare const createUserContext: <User>(value?: {
    token: {
        refresh: (address?: string, path?: string, data?: any, offset?: number, refreshMethod?: string) => Promise<string | undefined>;
        current: string | undefined;
    };
    current: User | undefined;
    signOut: (offset?: number, clear?: boolean) => Promise<string | undefined | void>;
    doSignOut: (content?: string, clear?: boolean) => boolean | undefined;
    isHidden: (item?: {
        content?: string;
        href?: string;
    }, userTypes?: UserType[]) => boolean | undefined;
} | undefined) => import("react").Context<{
    token: {
        refresh: (address?: string, path?: string, data?: any, offset?: number, refreshMethod?: string) => Promise<string | undefined>;
        current: string | undefined;
    };
    current: User | undefined;
    signOut: (offset?: number, clear?: boolean) => Promise<string | undefined | void>;
    doSignOut: (content?: string, clear?: boolean) => boolean | undefined;
    isHidden: (item?: {
        content?: string;
        href?: string;
    }, userTypes?: UserType[]) => boolean | undefined;
} | undefined>;
declare const isSignedIn: (element?: any, userTypes?: UserType[]) => boolean;
export { refreshToken, getUserType, getUserFlow, createUserContext, isSignedIn, signOut, catalog, getStorageToken, };
//# sourceMappingURL=user.d.ts.map