"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
class RequestError extends Error {
    code;
    codeText;
    response;
    constructor(code, codeText, response) {
        codeText = codeText === 'Error' ? response.name : codeText;
        const title = code && (codeText) ?
            `${code} - ${codeText}` :
            (code || codeText);
        const responseMessage = response?.message ? response.message : response;
        const message = title && responseMessage ?
            `${title}\n${responseMessage}` :
            (title || responseMessage);
        super(message.toString());
        this.code = code;
        this.codeText = codeText;
        this.response = response;
        console.error(this);
    }
}
exports.default = RequestError;
//# sourceMappingURL=requestError.js.map