"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.translateText = void 0;
// const { Translate } = require('@google-cloud/translate').v2;
// const translate = new Translate();
const _1 = require(".");
const escapeRegExp = (text) => {
    return text.replace(/[.*+?^${}()|[\]\\]/g, '\\$&'); // $& means the whole matched string
};
const encodeText = (text) => {
    return text
        .replace(new RegExp(escapeRegExp(' '), 'g'), '%20')
        .replace(new RegExp(escapeRegExp('\n'), 'g'), '$UR$');
};
const decodeText = (text) => {
    return text
        .replace(new RegExp(escapeRegExp('%20'), 'g'), ' ')
        .replace(new RegExp(escapeRegExp('$ UR $'), 'g'), '\n')
        .replace(new RegExp(escapeRegExp('$UR$'), 'g'), '\n');
};
const translateText = async (key, text, targetLanguage) => {
    if (targetLanguage === undefined ||
        targetLanguage === null ||
        targetLanguage?.toLowerCase()?.includes('en'))
        return text;
    if (key != undefined && key?.trim?.() !== '' && text != undefined && text?.trim?.() !== '')
        try {
            const data = await (0, _1.request)(`https://translation.googleapis.com/language/translate/v2?key=${key}`, 'get', `&q=${encodeText(text)}&target=${targetLanguage}&source=en`);
            text =
                decodeText(data?.data?.data?.translations[0]?.translatedText) || text;
            return text;
        }
        catch (error) {
            console.error(error);
        }
    return text;
};
exports.translateText = translateText;
//# sourceMappingURL=translate.js.map