"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cleanFromObject = exports.notInPages = exports.getPaths = exports.passProps = exports.toOptions = exports.toOption = exports.addPath = exports.getPath = exports.genPath = void 0;
const react_1 = require("react");
const genPath = (name, value) => {
    return value != undefined
        ? Array.isArray(value)
            ? name + '%5B%5D=' + value.join('&' + name + '%5B%5D=')
            : name + '=' + value
        : undefined;
};
exports.genPath = genPath;
const getPath = (oldPath) => {
    return oldPath != undefined && oldPath?.length > 0
        ? `${oldPath}&`
        : '?';
};
exports.getPath = getPath;
const addPath = (oldPath, addPath) => {
    // console.log('get addPath', oldPath, '-', addPath);
    return addPath != undefined && addPath != ''
        ? getPath(oldPath) + addPath
        : oldPath;
};
exports.addPath = addPath;
const toOption = (element, index) => {
    return { value: index, label: element?.name, ...element };
};
exports.toOption = toOption;
const toOptions = (array) => {
    return array && Array.isArray(array) ? array.map(toOption) : toOption(array);
};
exports.toOptions = toOptions;
const passProps = (properties, handleToken, currentTheme, currentLanguage, title, setTitle, search, setSearch) => {
    return (properties.children &&
        react_1.Children.map(properties.children, (child) => {
            return (0, react_1.cloneElement)(child, {
                handleToken: handleToken,
                theme: currentTheme,
                language: currentLanguage,
                title: title || child?.props?.title,
                setTitle: setTitle || child?.props?.setTitle,
                search: search || child?.props?.search,
                setSearch: setSearch || child?.props?.setSearch
            });
        }));
};
exports.passProps = passProps;
const getPaths = (pathname) => {
    const names = JSON.parse(JSON.stringify(pathname?.split('/')));
    for (let index = 0; index < names?.length || 0; index++) {
        const name = names[index];
        if (!name || name.trim() === '') {
            names.splice(index, 1);
            index--;
        }
    }
    return names;
};
exports.getPaths = getPaths;
const notInPages = (pathname, pages) => {
    const names = JSON.parse(JSON.stringify(pathname?.split('/')));
    for (const name of names) {
        if (pages[name])
            return false;
    }
    return true;
};
exports.notInPages = notInPages;
const cleanFromObject = (object, toClean) => {
    for (const key in object) {
        if (Object.prototype.hasOwnProperty.call(object, key)) {
            const element = object[key].replace('/', '');
            // console.log('getElement', element);
            if (toClean == element)
                toClean = undefined;
        }
    }
    return toClean;
};
exports.cleanFromObject = cleanFromObject;
//# sourceMappingURL=path.js.map